#include <cstdio>
#include <cmath>
#include <algorithm>

using namespace std;

const int maxd = 100010;

int p;
double prz[4][4];
char jed1[20], jed2[20];
int iljed;
char jed[4][20];
int wz[4][maxd];
int ilwz[4];

int get_nr(char *ss)
{
	for (int i = 0; i < iljed; ++i)
	{
		if (strcmp(jed[i], ss) == 0) return i;
	}
	strcpy(jed[iljed], ss);
	return iljed++;
}

char *get_ss(int nr)
{
	return jed[nr];
}

void read()
{
	iljed = 0;
	scanf("%d", &p);
	double w1, w2;
	for (int i = 0; i < 4; ++i)
	{
		ilwz[i] = 0;
		for (int k = 0; k< 4; ++k)
			prz[i][k] = -1.0;
		prz[i][i] = 1.0;
	}
	for (int i = 0; i < p; ++i)
	{
		scanf("%lf %s = %lf %s", &w1, jed1, &w2, jed2);
		int nr1 = get_nr(jed1);
		int nr2 = get_nr(jed2);
		prz[nr1][nr2] = w2;
		prz[nr2][nr1] = 1.0/w2;
	}
	bool jj = true;
	while (jj)
	{
		jj = false;
		for (int i = 0; i < iljed; ++i)
			for (int k = 0; k < iljed; ++k)
				if (i != k && prz[i][k] >= 0.0)
				{
					for (int a = 0; a < iljed; ++a)
						if (a!=k && a!=i && prz[k][a] >= 0.0 && prz[i][a] < 0.0)
						{
							prz[i][a] = prz[i][k] * prz[k][a];
							jj = true;
						}
				}
	}
/*	for (int i = 0; i < iljed; ++i)
	{
		for (int k = 0; k< iljed; ++k)
			printf(" %f", prz[i][k]);
		printf("\n");
	}
	printf("\n");*/
	int ww;
	scanf("%d", &ww);
	while (ww-->0)
	{
		int il;
		char tj[20];
		scanf("%d %s", &il, tj);
		int nr = get_nr(tj);
		wz[nr][ilwz[nr]++] = il;
	}
	for (int i = 0; i < iljed; ++i)
		sort(wz[i], wz[i] + ilwz[i]);
}

int bsearch(int nr, double il)
{
	int p = 0;
	int k = ilwz[nr];
	while (p+1 < k)
	{
		int sr = (p+k)/2;
		if (il < wz[nr][sr]) k = sr;
		else p = sr;
	}
	if (k >= ilwz[nr]) return wz[nr][p];
	if (il - wz[nr][p] <= wz[nr][k] - il) return wz[nr][p];
	return wz[nr][k];
}

void solve()
{
	int q, orgil;
	scanf("%d", &q);
	while (q-->0)
	{
		scanf("%d %s", &orgil, jed1);
		int wyn = -1, wyni;
		int nr = get_nr(jed1);
		for (int i = 0; i < iljed; ++i)
		if (ilwz[i] > 0)
		{
			double dil = orgil * prz[nr][i];
			int tw = bsearch(i, dil);
			double ndiff = fabs(tw * prz[i][nr] - orgil);
			double wdiff = fabs(wyn * prz[wyni][nr] - orgil);
//			printf("%d %s: %lf %lf\n", i, get_ss(i), ndiff, wdiff);
			if (wyn == -1 || ndiff < wdiff || (ndiff == wdiff && tw * prz[i][wyni] < wyn))
			{
				wyn = tw;
				wyni = i;
			}
		}
		printf("%d %s\n", wyn, get_ss(wyni));
	}
}

int main()
{
	int d;
	scanf("%d", &d);
	while (d-->0)
	{
		read();
		solve();
	}
	return 0;
}
